#ifndef DUNE_TECTONIC_OCTAVE_DUNEOCTAVE_HH
#define DUNE_TECTONIC_OCTAVE_DUNEOCTAVE_HH

#include <cassert>

#include <octave/oct.h>

#include "../samplefunctional.hh"

namespace Dune {
template <int dimension>
void octaveToDune(Array<double> const &from,
                  typename Dune::SampleFunctional<dimension>::SmallVector &to) {
  assert(from.length() == dimension);
  for (size_t i = 0; i < dimension; ++i)
    to[i] = from(i);
}

template <int dimension>
void octaveToDune(Matrix const &from,
                  typename Dune::SampleFunctional<dimension>::SmallMatrix &to) {
  dim_vector dims = from.dims();
  assert(dims.length() == 2);
  assert(dims(0) == 2);
  assert(dims(1) == 2);
  for (size_t i = 0; i < dimension; ++i)
    for (size_t j = 0; j < dimension; ++j)
      to[i][j] = from(i, j);
}

template <int dimension>
void duneToOctave(
    typename Dune::SampleFunctional<dimension>::SmallVector const &from,
    Array<double> &to) {
  assert(to.length() == dimension);
  for (size_t i = 0; i < dimension; ++i)
    to(i) = from[i];
}
}
#endif
