#include <dune/common/fmatrix.hh>
#include <dune/common/fvector.hh>
//#include <dune/grid/yaspgrid.hh>
#include <dune/grid/alugrid.hh>
#include <dune/istl/bcrsmatrix.hh>
#include <dune/istl/bvector.hh>

#include <dune/tectonic/myblockproblem.hh>
#include <dune/tectonic/myconvexproblem.hh>

// {{{ 2D
typedef Dune::FieldVector<double, 2> SmallVector2;
typedef Dune::FieldMatrix<double, 2, 2> SmallMatrix2;
typedef Dune::BlockVector<SmallVector2> VectorType2;
typedef Dune::BCRSMatrix<SmallMatrix2> OperatorType2;

typedef MyConvexProblem<OperatorType2, VectorType2> MyConvexProblemType2;
typedef MyBlockProblem<MyConvexProblemType2> MyBlockProblemType2;

typedef Dune::ALUGrid<2, 2, Dune::simplex, Dune::nonconforming> GridType2;
// typedef Dune::YaspGrid<2> GridType2;

template class MySolver<2, VectorType2, OperatorType2, GridType2,
                        MyBlockProblemType2>;
// }}}

// {{{ 3D
typedef Dune::FieldVector<double, 3> SmallVector3;
typedef Dune::FieldMatrix<double, 3, 3> SmallMatrix3;
typedef Dune::BlockVector<SmallVector3> VectorType3;
typedef Dune::BCRSMatrix<SmallMatrix3> OperatorType3;

typedef MyConvexProblem<OperatorType3, VectorType3> MyConvexProblemType3;
typedef MyBlockProblem<MyConvexProblemType3> MyBlockProblemType3;

typedef Dune::ALUGrid<3, 3, Dune::simplex, Dune::nonconforming> GridType3;
// typedef Dune::YaspGrid<3> GridType3;

template class MySolver<3, VectorType3, OperatorType3, GridType3,
                        MyBlockProblemType3>;
// }}}
