% -*- mode:octave -*-

clear all
close all

if exist('graphics_toolkit','file') graphics_toolkit('fltk') end

A=[
   1 0
   0 1
];
b=[
   1
   2.5
];
func = 'S'; % slope 1/100

x = -.1:.005: .4;
y =  .9:.005:1.1;
[X, Y] = meshgrid(x,y);
xlabel('x')
ylabel('y')

tic
for i=1:length(y)
  in = [ X(i,:); Y(i,:) ];
  f(i,:) = duneevaluate(A,b,func, in);
end
clear X Y;
toc

surf(x, y, f)
hold on;

steps = 1100;
vecs = zeros(steps + 1, 2);
diffs = zeros(steps, 2);

vecs(1,:) = [0; 0]; % So that we can always calculate a difference
vecs(2,:) = [0; 1]; % Start

for j = 2:steps+1
  vecs(j+1,:) = duneminimise(A,b,func,vecs(j,:));
  diffs(j,:) = vecs(j+1,:) - vecs(j,:);
  line([vecs(j,1) vecs(j+1,1)], ...
       [vecs(j,2) vecs(j+1,2)], ...
       [duneevaluate(A,b,func,vecs(j,:)') duneevaluate(A,b,func,vecs(j+1,:)')], ...
       'color', 'y');
end

axis tight;
xlabel x;
ylabel y;
hold off;
