% -*- mode:octave -*-

clear all
close all

if exist('graphics_toolkit','file') graphics_toolkit('fltk') end

A=[
   3 1.5
   1.5 4
];
b=[
   1
   2
];
func = 's'; % slope 1/2

x = -50:1:300;
y = -125:1:50;
[X, Y] = meshgrid(x,y);
xlabel('x')
ylabel('y')

tic
for i=1:length(y)
  in = [ X(i,:); Y(i,:) ];
  f(i,:) = duneevaluate(A,b,func,in);
end
clear X Y;
toc

surf(x, y, f)
hold on;

steps = 10;
vecs = zeros(steps + 1, 2);
diffs = zeros(steps, 2);

vecs(1,:) = [  0; 0]; % So that we can always calculate a difference
vecs(2,:) = [279; 0]; % Start

for j = 2:steps+1
  vecs(j+1,:) = duneminimise(A,b,func,vecs(j,:));
  diffs(j,:) = vecs(j+1,:) - vecs(j,:);
  line([vecs(j,1) vecs(j+1,1)], ...
       [vecs(j,2) vecs(j+1,2)], ...
       [duneevaluate(A,b,func,vecs(j,:)') duneevaluate(A,b,func,vecs(j+1,:)')], ...
       'color', 'y');
end

axis tight;
xlabel x;
ylabel y;
hold off;
