#include "vtk.hh"

#include <dune/common/fmatrix.hh>
#include <dune/common/fvector.hh>
//#include <dune/grid/yaspgrid.hh>
#include <dune/grid/alugrid.hh>
#include <dune/istl/bvector.hh>

#include <dune/fufem/functionspacebases/p0basis.hh>
#include <dune/fufem/functionspacebases/p1nodalbasis.hh>

typedef Dune::BlockVector<Dune::FieldVector<double, 1>> SingletonVectorType;

// {{{ 2D
typedef Dune::FieldVector<double, 2> SmallVector2;
typedef Dune::FieldMatrix<double, 2, 2> SmallMatrix2;
typedef Dune::BlockVector<SmallVector2> VectorType2;

typedef Dune::ALUGrid<2, 2, Dune::simplex, Dune::nonconforming> GridType2;
// typedef Dune::YaspGrid<2> GridType2;
typedef GridType2::LeafGridView GridView2;
typedef P1NodalBasis<GridView2, double> P1Basis2;
typedef P0Basis<GridView2, double> P0Basis2;

template void writeVtk<P1Basis2, P0Basis2, VectorType2, SingletonVectorType,
                       GridView2>(P1Basis2 vertexBasis,
                                  VectorType2 displacement,
                                  SingletonVectorType state, P0Basis2 cellBasis,
                                  SingletonVectorType stress,
                                  GridView2 gridView, std::string filename);
// }}}

// {{{ 3D
typedef Dune::FieldVector<double, 3> SmallVector3;
typedef Dune::FieldMatrix<double, 3, 3> SmallMatrix3;
typedef Dune::BlockVector<SmallVector3> VectorType3;

typedef Dune::ALUGrid<3, 3, Dune::simplex, Dune::nonconforming> GridType3;
// typedef Dune::YaspGrid<3> GridType3;
typedef GridType3::LeafGridView GridView3;
typedef P1NodalBasis<GridView3, double> P1Basis3;
typedef P0Basis<GridView3, double> P0Basis3;

template void writeVtk<P1Basis3, P0Basis3, VectorType3, SingletonVectorType,
                       GridView3>(P1Basis3 vertexBasis,
                                  VectorType3 displacement,
                                  SingletonVectorType state, P0Basis3 cellBasis,
                                  SingletonVectorType stress,
                                  GridView3 gridView, std::string filename);
// }}}
